routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('admin.home');
})->middleware('auth');

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');
Route::resource('companies', 'CompanyController')->middleware('auth');
Route::resource('users', 'UserController')->middleware('auth');

Route::get('/company/{slug}', 'CompanyUserController@company')->name('companyUsers');
Route::get('/user/{user}', 'CompanyUserController@user')->name('user');
Route::post('/feedback', 'CompanyUserController@feedback')->name('feedback');

app/User.php
<?php

namespace App;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Illuminate\Database\Eloquent\SoftDeletes;

class User extends Authenticatable
{
    use Notifiable;
    use SoftDeletes;
    /**
     * The attributes that are mass assignable.
     *
     * @author Chithra<cct@lbit.in>
     *
     * @var array
     */
    protected $fillable = [
        'name', 'email', 'password', 'type_id', 'photo', 'company_id'
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @author Chithra<cct@lbit.in>
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @author Chithra<cct@lbit.in>
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];
    
    /**
     * Define relationship with types table
     *
     * @author Chithra <cct@lbit.in>
     * 
     * @return Illuminate\Database\Eloquent\Model
     */
    public function type()
    {
    	return $this->belongsTo('App\Type');
    }
    
    /**
     * Define relationship with companies table
     *
     * @author Chithra <cct@lbit.in>
     * 
     * @return Illuminate\Database\Eloquent\Model
     */
    public function company()
    {
    	return $this->belongsTo('App\Company');
    }
}

app/Http/Controllers/UserController.php
<?php

namespace App\Http\Controllers;

use Mail;
use App\User;
use App\Company;
use App\Mail\WelcomeEmail;
use App\Http\Requests\UserRequest;
use Illuminate\Support\Facades\Hash;

class UserController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @author Chithra<cct@lbit.in>
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $users = User::where('type_id', 2)->orderBy('created_at', 'desc')->paginate(10);

        return view('admin.user.list', compact('users'));
    }

    /**
     * Show the form for creating a new user.
     *
     * @author Chithra<cct@lbit.in>
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $companies = Company::all('id', 'name');

        return view('admin.user.create', compact('companies'));
    }

    /**
     * Store a newly created user in storage.
     *
     * @author Chithra<cct@lbit.in>
     *
     * @param  \Illuminate\Http\UserRequest  $request
     * 
     * @return \Illuminate\Http\Response
     */
    public function store(UserRequest $request)
    {
        if ($request->get('name') && $request->get('email') && $request->hasFile('photo')) {
            $imageName = time().'.'.$request->photo->extension();
            $request->photo->move(public_path(config('feedback.path')), $imageName);
        }
        $user = new User([
            'name' => $request->get('name'),
            'email'=> $request->get('email'),
            'password' => Hash::make($request->get('password')),
            'type_id' => 2,
            'company_id' => $request->get('company_id') ?? 0,
            'photo' => $imageName?? ''
        ]);
        $user->save();
        Mail::to($request->get('email'))->send(new WelcomeEmail($user));

        return redirect()->route('users.index')->with('success', trans('admin.user_success'));
    }

    /**
     * Display the specified resource.
     *
     * @author Chithra<cct@lbit.in>
     *
     * @param App\User $user
     * 
     * @return \Illuminate\Http\Response
     */
    public function show(User $user)
    {
        return view('admin.user.view', compact('user'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @author Chithra<cct@lbit.in>
     *
     * @param  App\User $user
     * 
     * @return \Illuminate\Http\Response
     */
    public function edit(User $user)
    {
        $companies = Company::all('id', 'name');

        return view('admin.user.edit', compact(['user', 'companies']));
    }

    /**
     * Update the specified user in storage.
     *
     * @author Chithra<cct@lbit.in>
     *
     * @param  \Illuminate\Http\UserRequest  $request
     * @param  App\User $user
     * 
     * @return \Illuminate\Http\Response
     */
    public function update(UserRequest $request, User $user)
    {
        if ($request->get('name') && $request->get('email') && $request->hasFile('photo')) {
            $imageName = time().'.'.$request->photo->extension();
            $request->photo->move(public_path(config('feedback.path')), $imageName);
            if ($oldPhoto = $user->photo) {
                unlink(public_path(config('feedback.path').'/'.$user->photo));
            }
            $user->photo = $imageName?? '';
        }
        $user->name = $request->get('name');
        $user->email = $request->get('email');
        $user->company_id = $request->get('company_id');
        $user->update();

        return redirect()->route('users.index')->with('success',trans('admin.user_update'));
    }

    /**
     * Remove the specified user from storage.
     *
     * @author Chithra<cct@lbit.in>
     *
     * @param  App\User $user
     * 
     * @return \Illuminate\Http\Response
     */
    public function destroy(User $user)
    {
        $user->delete();
  
        return redirect()->route('users.index')->with('success',trans('admin.user_delete'));
    }
}

resources/views/admin/user/create.blade.php
@extends('layouts.app')

@section('content')
    <div class="row">
        <div class="col-lg-12">
            <div class="card-header">
                @lang('admin.new_user')
                <a class="btn btn-success float-right add_company" href="{{ route('users.index') }}">
                    @lang('admin.back')
                </a>
            </div>
        </div>
    </div>
    <div class="card-body">
        @if ($errors->any())
            <div class="alert alert-danger">
                @lang('admin.input_error')
                <ul>
                    @foreach ($errors->all() as $error)
                        <li>{{ $error }}</li>
                    @endforeach
                </ul>
            </div>
        @endif
        <form action="{{ route('users.store') }}" method="POST" enctype="multipart/form-data">
            @csrf
            <div class="form-group">
                <label for="user_name">@lang('admin.name')</label>
                <input type="text" class="form-control" id="user_name" placeholder="@lang('admin.field_error', ['name' => 'name'])" name="name" value="{{ old('name') }}">
            </div>
            <div class="form-group">
                <label for="user_email">@lang('admin.email')</label>
                <input type="text" class="form-control" id="user_email" placeholder="@lang('admin.field_error', ['name' => 'email'])" name="email" value="{{ old('email') }}">
                <input type="hidden" name="password" value="12345">
            </div>
            <div class="form-group">
                <label for="company">@lang('admin.company')</label>
                <select class="form-control" name="company_id">
                    <option>@lang('admin.select_company')</option>
                    @foreach ($companies as $comany)
                        <option value="{{ $comany->id }}">{{ $comany->name }} </option>
                    @endforeach    
                </select>
            </div>
            <div class="form-group">
                <label for="user_email">@lang('admin.photo')</label>
                <input type="file" name="photo">
            </div>
            <button type="submit" class="btn btn-primary">@lang('admin.submit')</button>
        </form>
    </div>
@endsection

resources/views/admin/user/edit.blade.php
@extends('layouts.app')

@section('content')
    <div class="row">
        <div class="col-lg-12">
            <div class="card-header">
                @lang('admin.edit_user') }}
                <a class="btn btn-success float-right add_company" href="{{ route('users.create') }}">
                    @lang('admin.users_add') }}
                </a>
            </div>
        </div>
    </div>
    <div class="card-body">
        @if ($errors->any())
            <div class="alert alert-danger">
                @lang('admin.input_error') }}
                <ul>
                    @foreach ($errors->all() as $error)
                        <li>{{ $error }}</li>
                    @endforeach
                </ul>
            </div>
        @endif
        <form method="post" action="{{ route('users.update',$user->id) }}" enctype="multipart/form-data">
            @method('PATCH')
            @csrf
            <div class="form-group">
                <label for="name">@lang('admin.name') }}</label>
                <input type="text" class="form-control" id="user_name" placeholder="@lang('admin.field_error', ['name' => 'name']) }}" name="name" value="{{ old('name', $user->name) }}">
            </div>
            <div class="form-group">
                <label for="email">@lang('admin.email') }}</label>
                <input type="text" class="form-control" id="user_email" placeholder="@lang('admin.field_error', ['name' => 'email']) }}" name="email" value="{{ old('email', $user->email) }}">
            </div>
            <div class="form-group">
                <label for="company">@lang('admin.company') }}</label>
                <select class="form-control" name="company_id">
                    <option>@lang('admin.select_company') }}</option>
                    @foreach ($companies as $comany)
                        <option value="{{ $comany->id }}" {{ ($comany->id == $user->company_id) ? 'selected' : '' }}> 
                            {{ $comany->name }} 
                        </option>
                    @endforeach    
                </select>
            </div>
            <div class="form-group">
                <label for="user_email">@lang('admin.photo') }}</label>
                <input type="file" name="photo">
                @if($user->photo)
                    <img class="user_photo" src="{{asset('/'.config('feedback.path').'/'.$user->photo)}}" alt="{{ $user->photo }}">
                @endif    
            </div>
            <button type="submit" class="btn btn-primary">@lang('admin.submit') }}</button>
        </form>
    </div>
@endsection

resources/views/admin/user/list.blade.php
@extends('layouts.app')

@section('content')
    <div class="row">
        <div class="col-lg-12">
            <div class="card-header">
                @lang('admin.users_title')
                <a class="btn btn-success float-right add_company" href="{{ route('users.create') }}">
                    @lang('admin.users_add')
                </a>
            </div>
        </div>
    </div>
    <div class="card-body">
        @if ($message = Session::get('success'))
            <div class="alert alert-success">
                <p>{{ $message }}</p>
            </div>
        @endif

        <table class="table table-bordered">
            <tr>
                <th>@lang('admin.si_no')</th>
                <th>@lang('admin.name')</th>
                <th>@lang('admin.email')</th>
                <th>@lang('admin.company')</th>
                <th>@lang('admin.photo')</th>
                <th>@lang('admin.actions')</th>
            </tr>
            @php
                $i = 0;
            @endphp
            @foreach ($users as $user)
                <tr>
                    <td>{{ ++$i }}</td>
                    <td>{{ $user->name }}</td>
                    <td>{{ $user->email }}</td>
                    <td>
                        @if ($company = $user->company)
                            {{ $company->name }}
                        @endif
                    </td>
                    <td>
                        @if ($user->photo)
                            <img class="user_photo" src="{{asset('/'.config('feedback.path').'/'.$user->photo)}}" alt="{{ $user->photo }}" />
                        @endif
                    </td>
                    <td>
                        <form action="{{ route('users.destroy', $user->id) }}" method="POST">
                            <a class="btn btn-info" href="{{ route('users.show', $user->id) }}">@lang('admin.show')</a>
                            <a class="btn btn-primary" href="{{ route('users.edit', $user->id) }}">@lang('admin.edit')</a>
                            @csrf
                            @method('DELETE')
                            <button type="submit" class="btn btn-danger">@lang('admin.delete')</button>
                        </form>
                    </td>
                </tr>
            @endforeach
        </table>
        {!! $users->links() !!}
    </div>
@endsection

resources/views/admin/user/view.blade.php
@extends('layouts.app')

@section('content')
    <div class="row">
        <div class="col-lg-12">
            <div class="card-header">
                @lang('admin.users_title')
                <a class="btn btn-success float-right add_company" href="{{ route('users.index') }}">
                    @lang('admin.back')
                </a>
            </div>
        </div>
    </div>
    <div class="card-body">
        <table class="table table-bordered">
            <tr>
                <th>@lang('admin.name'):</th>
                <td>{{ $user->name }}</td>
            </tr>
            <tr>
                <th>@lang('admin.email'):</th>
                <td>{{ $user->email }}</td>
            </tr>
            <tr>
                <th>@lang('admin.company'):</th>
                <td>
                    @if ($company = $user->company)
                        {{ $company->name }}
                    @endif
                </td>
            </tr>
            <tr>
                <th>@lang('admin.photo'):</th>
                <td>
                    <img class="user_photo" src="{{asset('/'.config('feedback.path').'/'.$user->photo)}}" alt="{{ $user->photo }}">
                </td>
            </tr>
        </table>
    </div>
@endsection